package _VisualDVM.Passes.All;
import Common.Passes.Pass;
import Common.Utils.Utils_;
import Common.Visual.Windows.Dialog.VDirectoryChooser;
import _VisualDVM.Constants;
import _VisualDVM.Current;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.DBLastProject.DBLastProject;
import _VisualDVM.Passes.PassCode;
import _VisualDVM.ProjectData.Project.db_project_info;
import _VisualDVM.ProjectData.ProjectView;
import _VisualDVM.Utils;

import java.io.File;
public class OpenCurrentProject extends Pass<db_project_info> {
    Mode mode = Mode.Undefined;
    File dir = null;
    boolean root_changes;
    db_project_info new_root = null;
    VDirectoryChooser directoryChooser = new VDirectoryChooser("Выбор домашней папки проекта");
    @Override
    public String getIconPath() {
        return "/icons/OpenProject.png";
    }
    @Override
    public String getButtonText() {
        return "";
    }
    @Override
    protected boolean needsAnimation() {
        return true;
    }
    boolean needsOpen() {
        return !Global.mainModule.HasProject() || !Global.mainModule.getProject().Home.equals(dir);
    }
    //-----------------
    @Override
    protected boolean canStart(Object... args) throws Exception {
        mode = Mode.Directory;
        dir = null;
        target = null;
        if (args.length == 0) {
            Utils.ChooserProjectsSearchDirectory(directoryChooser);
            dir = directoryChooser.ShowDialog();
        } else {
            Object arg = args[0];
            if (arg instanceof File) {
                dir = (File) arg;
            } else if (arg instanceof db_project_info) {
                mode = Mode.ProjectInfo;
                target = (db_project_info) arg;
                dir = target.Home;
                return needsOpen();
            }
        }
        if ((dir != null) && needsOpen()) {
            if (!dir.isDirectory()) {
                Log.Writeln_(Utils_.Brackets(dir) + "\nне является папкой!");
                return false;
            }
            if (dir.getName().equals(Constants.data)) {
                Log.Writeln_(Utils_.Brackets(dir) + "\nявляется служебной папкой визуализатора!");
                return false;
            }
            return Utils.validateProjectFolder(dir, Log) && Utils.containsSource(dir, true);
        }
        return false;
    }
    @Override
    protected void performPreparation() throws Exception {
        Global.mainModule.getPass(PassCode.CloseCurrentProject).Do();
    }
    @Override
    protected void body() throws Exception {
        root_changes = true;
        switch (mode) {
            case Directory:
                if (Global.mainModule.HasRoot()) {
                    db_project_info root = Global.mainModule.getRoot();
                    db_project_info project = root.find_version_r(dir);
                    if (project != null) {
                        Utils_.MainLog.Print("версия найдена в текущем корне");
                        //версия уже существует. и выстраивать дерево второй раз не нужно.
                        //как и отображать дерево.
                        target = project;
                        target.Open();
                        target.SynchronizeSapforProperties();
                        root_changes = false;
                        return;
                    }
                }
                target = new db_project_info(dir);
                new_root = target.CreateVersionsTree();
                target.Open();
                target.SynchronizeSapforProperties();
                break;
            case ProjectInfo:
                //если нам суют версию. значит уже априори корень не сменится.
                root_changes = false;
                target.Open();
                target.SynchronizeSapforProperties();
                break;
        }
    }
    @Override
    protected void performDone() throws Exception {
        Global.mainModule.set(Current.Project, target);
        Global.mainModule.set(Current.ProjectView, ProjectView.Files);
        if (root_changes)
            Global.mainModule.set(Current.Root, new_root);
        Global.mainModule.getPass(PassCode.UpdateProperty).Do("ProjectsSearchDirectory", dir.getParent());
        DBLastProject lastProject;
        if ((Global.mainModule.getDb()).lastProjects.containsKey(target.Home.getAbsolutePath())) {
            lastProject = Global.mainModule.getDb().lastProjects.get(target.Home.getAbsolutePath());
            lastProject.RefreshOpenTime();
            Global.mainModule.getDb().Update(lastProject);
        } else {
            lastProject = new DBLastProject(target);
            Global.mainModule.getDb().Insert(lastProject);
        }
        target.setInfo(lastProject);
    }
    @Override
    protected void showDone() throws Exception {
        if (root_changes)
            Global.mainModule.getUI().CreateVersionsWindow();
        Global.mainModule.getUI().getVersionsWindow().ShowProjectVariants();
        Global.mainModule.getUI().getVersionsWindow().BlockVariants();
        //-
        Global.mainModule.getUI().getMainWindow().ShowProject();
        //криво. но при тихом режиме открытие файлов все равно не понадобится. LastOpenedProjectsMenu
        Global.mainModule.getPass(PassCode.OpenCurrentFile).Do(target.getLastOpenedFile());
    }
    @Override
    protected void FocusResult() {
        Global.mainModule.getUI().getMainWindow().FocusProject();
    }
    enum Mode {
        Undefined,
        Directory,
        ProjectInfo
    }
}
